unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, VCLTee.TeEngine,
  Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart, VCLTee.TeeComma;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    TeeCommander1: TTeeCommander;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure VectorGetMarkText(Sender:TChartSeries; ValueIndex:Integer; var MarkText:String);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses TeeSurfa, TeePoin3, Math;

procedure TForm1.FormCreate(Sender: TObject);
var FPoint3DSeries: TPoint3DSeries;
    MaxX, MaxY, MaxZ: Double;
    MidX, MidY, MidZ: Double;
begin
  with Chart1 do
  begin
    Chart3DPercent:=100;
    Aspect.Orthogonal:=False;
    Aspect.Zoom:=70;
    Legend.Hide;
  end;

  FPoint3DSeries:=Chart1.AddSeries(TPoint3DSeries) as TPoint3DSeries;
  FPoint3DSeries.Pointer.Hide;
  FPoint3DSeries.FillSampleValues;

  with Chart1.AddSeries(TVector3DSeries) as TVector3DSeries do
  begin
    Color:=clRed;
    Pen.Width:=2;
    ArrowHeight:=10;
    ArrowWidth:=10;

    MidX := FPoint3DSeries.MinXValue+(FPoint3DSeries.MaxXValue-FPoint3DSeries.MinXValue)/2;
    MidY := FPoint3DSeries.MinYValue+(FPoint3DSeries.MaxYValue-FPoint3DSeries.MinYValue)/2;
    MidZ := FPoint3DSeries.MinZValue+(FPoint3DSeries.MaxZValue-FPoint3DSeries.MinZValue)/2;
    MaxX := Max(FPoint3DSeries.MaxXValue, Abs(FPoint3DSeries.MinXValue));
    MaxY := Max(FPoint3DSeries.MaxYValue, Abs(FPoint3DSeries.MinYValue));
    MaxZ := Max(FPoint3DSeries.MaxZValue, Abs(FPoint3DSeries.MinZValue));
    AddVector(MidX,MidY,MidZ, MaxX,MidY,MidZ, 'a', clRed);
    AddVector(MidX,MidY,MidZ, MidX,MaxY,midZ, 'b', clGreen);
    AddVector(MidX,MidY,MidZ, MidX,MidY,MaxZ, 'c', clBlue);
    Marks.Show;
    OnGetMarkText:=VectorGetMarkText;
  end;

  Chart1.Draw;
end;

procedure TForm1.VectorGetMarkText(Sender:TChartSeries; ValueIndex:Integer; var MarkText:String);
begin
  if Assigned(Sender) and (ValueIndex>-1) and (ValueIndex<Sender.count) and
     Assigned(Sender.Marks.Positions) and Assigned(Sender.Marks.Positions[ValueIndex]) then
  begin
    with TVector3DSeries(Sender), Marks.Positions[ValueIndex] do
    begin
      Custom:=True;
      LeftTop:=ParentChart.Canvas.Calculate3DPosition(CalcXPosValue(EndXValues[ValueIndex]),
                                                      CalcYPosValue(EndYValues[ValueIndex]),
                                                      ParentChart.Axes.Depth.CalcPosValue(EndZValues[ValueIndex]));
    end;
  end;
end;

end.
